HDU 1058 Humble Numbers (动规+寻找丑数问题)

Humble Numbers

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)

Total Submission(s): 16742    Accepted Submission(s): 7280

Problem Description

A number whose only prime factors are 2,3,5 or 7 is called a humble number. The sequence 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 12, 14, 15, 16, 18, 20, 21, 24, 25, 27, ... shows the first 20 humble numbers.

Write a program to find and print the nth element in this sequence

Input

The input consists of one or more test cases. Each test case consists of one integer n with 1 <= n <= 5842. Input is terminated by a value of zero (0) for n.

Output

For each test case, print one line saying "The nth humble number is number.". Depending on the value of n, the correct suffix "st", "nd", "rd", or "th" for the ordinal number nth has to be used like it is shown in the sample output.

Sample Input

1
2
3
4
11
12
13
21
22
23
100
1000
5842
0

Sample Output

The 1st humble number is 1.
The 2nd humble number is 2.
The 3rd humble number is 3.
The 4th humble number is 4.
The 11th humble number is 12.
The 12th humble number is 14.
The 13th humble number is 15.
The 21st humble number is 28.
The 22nd humble number is 30.
The 23rd humble number is 32.
The 100th humble number is 450.
The 1000th humble number is 385875.
The 5842nd humble number is 2000000000.

Source

University of Ulm Local Contest 1996

Recommend

JGShining   |   We have carefully selected several similar problems for you:  1176 1421 1024 1025 1081

大神找规律,我这种弱菜只能看别人代码了。。orz。

分别乘2,乘3,乘5,乘7,哪个小取哪个,乘过之后,p2,p3,p5,p7的值还要改变一下。。。其实就是一个光搜的过程,,,,题目。

每个数都可以分解成有限个2 3 5 7 的乘积,dp方程为dp[i]=f[i]=min(f[a]*2,min(f[b]*3,min(f[c]*5,f[d]*7)))

找到比f[i-1]大且最小的数,在这里用到了滚动查找;

下面详细解释:

a表示f[]数组中,下标为a的数*2 可能得到当前的 f[i];若是则++

b表示f[]数组中,下标为b的数* 3 可能得到当前的f[i];若是则++

c表示f[]数组中,下标为b的数* 5 可能得到当前的f[i];若是则++

d表示f[]数组中,下标为b的数* 7 可能得到当前的f[i];若是则++

求出他们中的min,则为f[i];

 如果一个数的质因子只有2、3、5或7,那么这个数被称为Humble Numbers(差数)。将正整数正序排列(1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 12, 14, 15, 16, 18, 20, 21, 24, 25, 27, ... )你会发现前20个Humble Numbers(差数)。
    现在,你的任务是编写一个程序将第n个Humble Numbers(差数)找出并打印出来。
    
输入规范:
输入的数有许多组,其中的n均满足1 <= n <= 5842。如果输入0,则表示终止。
输出规范:
对于每一组数,分列几行输出“The nth humble number is number.”,其中nth必须根据英语词法规范写为“1st、2nd、3rd、4th、5th、6th、7th、8th、9th、10th... ”。

还用到英语。。。orz。

一般来说个位数是1为st,个位数为2是nd,个位数为3是rd;但是有例外,11, 12 ,13均为th,同时111,112,113均为th,除此之外,其他都是th;

代码:

#include <iostream>
#include <algorithm>
using namespace std;
#define M 50000
__int64 min(__int64 a,__int64 b,__int64 c,__int64 d){
    __int64 x=a<b?a:b;
    __int64 y=c<d?c:d;
    return x<y?x:y;
}
__int64 vis[M];
int main(__int64 p2,__int64 p3,__int64 p5,__int64 p7)
{
    int i=1,n,cur;
    p2=p3=p5=p7=1;
    memset(vis,0,sizeof(vis)); vis[1]=1;
    while(vis[i]<=2000000000)
    {
        vis[++i]=min(vis[p2]*2,vis[p3]*3,vis[p5]*5,vis[p7]*7);
        if(vis[i]==vis[p2]*2) p2++;
        if(vis[i]==vis[p3]*3) p3++;
        if(vis[i]==vis[p5]*5) p5++;
        if(vis[i]==vis[p7]*7) p7++;
    }
    while(scanf("%d",&n)!=EOF,n)
    {
        string ss;
        if(n%10==1&&n%100!=11)
            printf("The %dst humble number is %I64d.\n",n,vis[n]);
        else if(n%10==2&&n%100!=12)
            printf("The %dnd humble number is %I64d.\n",n,vis[n]);
        else if(n%10==3&&n%100!=13)
            printf("The %drd humble number is %I64d.\n",n,vis[n]);
        else
            printf("The %dth humble number is %I64d.\n",n,vis[n]);  

    }
return 0;
}
时间: 2024-10-12 16:20:54

HDU 1058 Humble Numbers (动规+寻找丑数问题)的相关文章

HDU 1058 Humble Numbers (dp+打表)

先是想筛法素数表啊,然后1~2000000000枚举打表啊,结果越想越不对. 后来想到唯一分解定理,可是怎么实现呢..果然还是需要努力啊.. 研究了discuss代码,码之~ ~~~~ dp的思想,若dp[i]是Humble Numbers,那么dp[i]*2,dp[i]*3,dp[i]*5,dp[i]*7都将是Humble Numbers. 所以只需要注意连续性便好了. #include<cstdio> #include<algorithm> #include<cmath&

HDU 1058 Humble Numbers (打表)

题目链接:HDU 1058 Humble Numbers 题意:一些数他们的素数因子只有2,3,5,7.求这些数. 因为这些数的因子只可能是2,3,5,7.所以通过2,3,5,7这个四个数构造这个数列,这个数列靠后的数必定是前面的数乘上2,3,5,7得到. AC代码: #include<stdio.h> #include<set> #define ll __int64 using namespace std; set<ll> s; set<ll>::iter

HDU 1058 Humble Numbers(DP,数)

题意  所有只能被2,3,5,7这4个素数整除的数称为Humble Number  输入n  输出第n个Humble Number 1是第一个humble number  对于一个Humble Number  a  有2*a,3*a,5*a,7*a都是Humble Number  可以以1为基数  依次展开即可得到一定范围内的Humble Number 用i,j,k,l分别记录 2,3,5,7分别乘到了第几个Humble Number  当前在计算第cnt个Humble Number  那么有

【转】HDU 1058 Humble Numbers:寻找丑数问题?DP?

这个和上一道HDU 3199 Hamming Problem是类似的,有了思路就开始码代码了,可是!序数词的写法不对(代码注释部分)又上网普及了序数词的写法··· 搜到其他解题报告 其中有把这道题分类为DP的,最优子结构?无后效性? 还有“寻找丑数问题” 详情点这里. #include<iostream> #include<cstdio> using namespace std; const int Size=5842; long long num[Size+1]; int mai

HDU 1058 Humble Numbers &amp;&amp; NOJ 1420 丑数 (数位dp)

Humble Numbers                          Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)                                          Total Submission(s): 18555    Accepted Submission(s): 8080 Problem Description A numb

HDU 1058 Humble Numbers(递推)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1058 题意:丑数是指只有2,3,5 or 7这几个素因数的数(所以1也是丑数),找到第n个丑数. 思路:除了2,3,5,7任何一个丑数都是由另一个丑数乘上2,或3,或5,或7得到的. 所以可以用优先队列,每取出一个丑数就入队他们乘上2,3,5,7得到的四个丑数,这样每个丑数都生成了.复杂度还是不错的,不过按这种方法会生成比较大的数,最终爆掉int,所以要用long long //93MS 1228K

hdu 1058 Humble Numbers || poj 1338(dp)

两题都是一样的题目 只是hdu 1058 多了个7 题意:求一个每个数因子仅含2 3 5 7 的 序列 问 第n个数是几 思路: ans[i]=min(min(ans[n2]*2,ans[n3]*3),min(ans[n5]*5,ans[n7]*7)); if(ans[i]==ans[n2]*2) n2++; if(ans[i]==ans[n3]*3) n3++; if(ans[i]==ans[n5]*5) n5++; if(ans[i]==ans[n7]*7) n7++; hdu 1058 #

HDU 1058 Humble Numbers (DP)

Humble Numbers Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 18238    Accepted Submission(s): 7934 Problem Description A number whose only prime factors are 2,3,5 or 7 is called a humble numbe

hdu 1058 Humble Numbers

Humble Numbers Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 18406    Accepted Submission(s): 8010 Problem Description A number whose only prime factors are 2,3,5 or 7 is called a humble numbe